<!doctype html>
<html lang="en">
 <head>
  <meta charset="UTF-8">
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <meta name="generator" content="Asciidoctor 2.0.23">
  <meta name="author" content="Copyright (c) 2010, 2024 Contributors to the Eclipse Foundation">
  <link rel="icon" type="image/png" href="../favicon.png">
  <title>Buffers | Chi documentation</title>
  <link rel="stylesheet" href="../assets/asciidoctor-escet-chi.css">
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
  <link rel="stylesheet" href="../assets/styles/asciidoctor-highlightjs-escet.min.css"><!--
  Copyright (c) 2010, 2024 Contributors to the Eclipse Foundation

  See the NOTICE file(s) distributed with this work for additional
  information regarding copyright ownership.

  This program and the accompanying materials are made available under the terms
  of the MIT License which is available at https://opensource.org/licenses/MIT

  SPDX-License-Identifier: MIT
-->
  
  <script type="text/javascript" src="../assets/asciidoctor-escet-chi.js"></script>
 </head>
 <body class="book toc2 toc-left" onload="onLoad()">
  <div id="header">
   <div id="toc" class="toc2">
    <p class="website-link">Part of: <a href="..">Chi website</a></p>
    <div id="toctitle">
     Chi documentation
    </div>
    <ul class="sectlevel1">
     <li class="toc-item">
      <div class="toc-item-marker"></div><a href="../documentation.html">Home</a></li>
     <li class="toc-cur-page-ancestor toc-item toc-item-parent expanded">
      <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="index.html">Chi Tutorial</a>
      <ul class="sectlevel2">
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="introduction.html">Introduction</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="introduction.html#chi-in-a-nutshell">Chi in a nutshell</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="introduction.html#exercises">Exercises</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="datatypes.html">Data types</a>
        <ul class="sectlevel3">
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="datatypes.html#elementary-types">Elementary types</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="datatypes.html#booleans">Booleans</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="datatypes.html#enumerations">Enumerations</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="datatypes.html#numbers">Numbers</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="datatypes.html#strings">Strings</a></li>
          </ul></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="datatypes.html#tuple-types">Tuple types</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="datatypes.html#notation">Notation</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="datatypes.html#operator">Operator</a></li>
          </ul></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="datatypes.html#container-types">Container types</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="datatypes.html#lists">Lists</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="datatypes.html#initialization">Initialization</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="datatypes.html#sets">Sets</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="datatypes.html#dictionaries">Dictionaries</a></li>
          </ul></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="datatypes.html#custom-types">Custom types</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="datatypes.html#exercises">Exercises</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="statements.html">Statements</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="statements.html#the-assignment-statement">The assignment statement</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="statements.html#the-if-statement">The <code>if</code> statement</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="statements.html#the-while-statement">The <code>while</code> statement</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="statements.html#the-for-statement">The <code>for</code> statement</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="statements.html#notes">Notes</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="statements.html#exercises">Exercises</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="functions.html">Functions</a>
        <ul class="sectlevel3">
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="functions.html#sorted-lists">Sorted lists</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="functions.html#sort">Sort</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="functions.html#insert">Insert</a></li>
          </ul></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="input-output.html">Input and output</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="input-output.html#the-read-function">The <code>read</code> function</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="input-output.html#reading-from-a-file">Reading from a file</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="input-output.html#advanced-reading-from-a-file">Advanced reading from a file</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="input-output.html#the-write-statement">The <code>write</code> statement</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="input-output.html#writing-to-a-file">Writing to a file</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="stochastic-behavior.html">Modeling stochastic behavior</a>
        <ul class="sectlevel3">
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="stochastic-behavior.html#distributions">Distributions</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="stochastic-behavior.html#constant-distributions">Constant distributions</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="stochastic-behavior.html#discrete-distributions">Discrete distributions</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="stochastic-behavior.html#continuous-distributions">Continuous distributions</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="stochastic-behavior.html#references">References</a></li>
          </ul></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="stochastic-behavior.html#simulating-stochastic-behavior">Simulating stochastic behavior</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="stochastic-behavior.html#exercises">Exercises</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="processes.html">Processes</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="processes.html#a-single-process">A single process</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="processes.html#a-process-in-a-process">A process in a process</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="processes.html#many-processes">Many processes</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="channels.html">Channels</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="channels.html#a-channel">A channel</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="channels.html#synchronization-channels">Synchronization channels</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="channels.html#two-channels">Two channels</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="channels.html#more-senders-or-receivers">More senders or receivers</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="channels.html#notes">Notes</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="channels.html#exercises">Exercises</a></li>
        </ul></li>
       <li class="toc-cur-page toc-item toc-item-parent expanded">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="#">Buffers</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="#a-one-place-buffer">A one-place buffer</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="#a-single-process-buffer">A single process buffer</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="#an-infinite-buffer">An infinite buffer</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="#a-token-buffer">A token buffer</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="#a-priority-buffer">A priority buffer</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="#exercises">Exercises</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="servers.html">Servers with time</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="servers.html#the-clock">The clock</a></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="servers.html#adding-time">Adding time</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="servers.html#a-deterministic-system">A deterministic system</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="servers.html#a-stochastic-system">A stochastic system</a></li>
          </ul></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="servers.html#two-servers">Two servers</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="servers.html#serial-system">Serial system</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="servers.html#parallel-systems">Parallel systems</a></li>
          </ul></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="servers.html#assembly">Assembly</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="servers.html#exercises">Exercises</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="conveyors.html">Conveyors</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="conveyors.html#timers">Timers</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="conveyors.html#a-conveyor">A conveyor</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="conveyors.html#a-priority-conveyor">A priority conveyor</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="conveyors.html#exercises">Exercises</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="experiments.html">Simulations and experiments</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="experiments.html#simulating-finite-systems">Simulating finite systems</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="experiments.html#simulating-infinite-systems">Simulating infinite systems</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="experiments.html#simulating-several-scenarios">Simulating several scenarios</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="svg-visualization.html">SVG visualization</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="svg-visualization.html#the-svg-file-format">The SVG file format</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="svg-visualization.html#visualization">Visualization</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="svg-example.html">SVG visualization example</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="svg-example.html#buffer-visualization">Buffer visualization</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="svg-example.html#vertical-coordinates-trickery">Vertical coordinates trickery</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="svg-example.html#server-process">Server process</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="svg-example.html#visualizing-the-server">Visualizing the server</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="svg-example.html#copying-svg-elements">Copying SVG elements</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="svg-example.html#moving-svg-elements">Moving SVG elements</a></li>
        </ul></li>
      </ul></li>
     <li class="toc-item toc-item-parent">
      <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../reference-manual/index.html">Chi Reference Manual</a>
      <ul class="sectlevel2">
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../reference-manual/globals.html">Global definitions</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/globals.html#enumeration-definitions">Enumeration definitions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/globals.html#type-definitions">Type definitions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/globals.html#constant-definitions">Constant definitions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/globals.html#process-definitions">Process definitions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/globals.html#model-definitions">Model definitions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/globals.html#function-definitions">Function definitions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/globals.html#experiment-definitions">Experiment definitions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/globals.html#formal-parameters">Formal parameters</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../reference-manual/statements.html">Statements</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/statements.html#local-variables">Local variables</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/statements.html#assignment-statement">Assignment statement</a></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../reference-manual/statements.html#iterative-statements">Iterative statements</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../reference-manual/statements.html#while-loop-statement">While loop statement</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../reference-manual/statements.html#for-loop-statement">For loop statement</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../reference-manual/statements.html#break-statement">Break statement</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../reference-manual/statements.html#continue-statement">Continue statement</a></li>
          </ul></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/statements.html#choice-statement">Choice statement</a></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../reference-manual/statements.html#sub-process-statements">Sub-process statements</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../reference-manual/statements.html#run-and-start-statements">Run and start statements</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../reference-manual/statements.html#finish-statement">Finish statement</a></li>
          </ul></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../reference-manual/statements.html#communication-statements">Communication statements</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../reference-manual/statements.html#send-statement">Send statement</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../reference-manual/statements.html#receive-statement">Receive statement</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../reference-manual/statements.html#select-statement">Select statement</a></li>
          </ul></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../reference-manual/statements.html#other-statements">Other statements</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../reference-manual/statements.html#delay-statement">Delay statement</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../reference-manual/statements.html#write-statement">Write statement</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../reference-manual/statements.html#close-statement">Close statement</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../reference-manual/statements.html#return-statement">Return statement</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../reference-manual/statements.html#exit-statement">Exit statement</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../reference-manual/statements.html#pass-statement">Pass statement</a></li>
          </ul></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../reference-manual/expressions.html">Expressions</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/expressions.html#typed-expressions">Typed expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/expressions.html#enumeration-value">Enumeration value</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/expressions.html#boolean-expressions">Boolean expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/expressions.html#integer-expressions">Integer expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/expressions.html#real-number-expressions">Real number expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/expressions.html#string-expressions">String expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/expressions.html#list-expressions">List expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/expressions.html#set-expressions">Set expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/expressions.html#dictionary-expressions">Dictionary expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/expressions.html#tuple-expression">Tuple expression</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/expressions.html#file-handle-expressions">File handle expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/expressions.html#read-expression">Read expression</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/expressions.html#timer-expressions">Timer expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/expressions.html#channel-expressions">Channel expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/expressions.html#distribution-expressions">Distribution expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/expressions.html#process-expressions">Process expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/expressions.html#instance-expressions">Instance expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/expressions.html#matrix-expression">Matrix expression</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/expressions.html#cast-expressions">Cast expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/expressions.html#function-call-expressions">Function call expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/expressions.html#operator-priorities">Operator priorities</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../reference-manual/stdlib.html">Standard library functions</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/stdlib.html#integer-functions">Integer functions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/stdlib.html#real-number-functions">Real number functions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/stdlib.html#string-functions">String functions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/stdlib.html#list-functions">List functions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/stdlib.html#set-functions">Set functions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/stdlib.html#dictionary-functions">Dictionary functions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/stdlib.html#timer-functions">Timer functions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/stdlib.html#file-functions">File functions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/stdlib.html#process-instance-functions">Process instance functions</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../reference-manual/distributions.html">Distributions</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/distributions.html#constant-distributions">Constant distributions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/distributions.html#discrete-distributions">Discrete distributions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/distributions.html#continuous-distributions">Continuous distributions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/distributions.html#references">References</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../reference-manual/types.html">Types</a>
        <ul class="sectlevel3">
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../reference-manual/types.html#elementary-types">Elementary types</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../reference-manual/types.html#boolean-type">Boolean type</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../reference-manual/types.html#integer-type">Integer type</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../reference-manual/types.html#real-type">Real type</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../reference-manual/types.html#string-type">String type</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../reference-manual/types.html#file-type">File type</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../reference-manual/types.html#instance-type">Instance type</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../reference-manual/types.html#timer-type">Timer type</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../reference-manual/types.html#matrix-type">Matrix type</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../reference-manual/types.html#void-type">Void type</a></li>
          </ul></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../reference-manual/types.html#container-types">Container types</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../reference-manual/types.html#list-type">List type</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../reference-manual/types.html#set-type">Set type</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../reference-manual/types.html#dictionary-type">Dictionary type</a></li>
          </ul></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/types.html#tuple-type">Tuple type</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/types.html#channel-type">Channel type</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/types.html#distribution-type">Distribution type</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/types.html#function-type">Function type</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/types.html#process-type">Process type</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../reference-manual/lexicals.html">Lexical syntax</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/lexicals.html#whitespace">Whitespace</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/lexicals.html#comment">Comment</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/lexicals.html#names">Names</a></li>
        </ul></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../reference-manual/migration.html">Model migration</a></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../reference-manual/svg-visualization.html">SVG visualization</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/svg-visualization.html#svg-interface">SVG interface</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/svg-visualization.html#visualization-modification-commands">Visualization modification commands</a></li>
        </ul></li>
      </ul></li>
     <li class="toc-item toc-item-parent">
      <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tool-manual/index.html">Chi Tool Manual</a>
      <ul class="sectlevel2">
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tool-manual/operation.html">Software operation</a>
        <ul class="sectlevel3">
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tool-manual/operation.html#compile-and-simulate">Compile and simulate</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../tool-manual/operation.html#quick-simulate">Quick simulate</a></li>
          </ul></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tool-manual/operation.html#compile-only">Compile only</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tool-manual/operation.html#simulate-a-compiled-model">Simulate a compiled model</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tool-manual/operation.html#terminating-a-simulation">Terminating a simulation</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tool-manual/command-line.html">Command line options</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tool-manual/command-line.html#simulator-options">Simulator options</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tool-manual/command-line.html#general-application-options">General application options</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tool-manual/command-line.html#compiler-options">Compiler options</a></li>
        </ul></li>
      </ul></li>
     <li class="toc-item toc-item-parent">
      <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../release-notes.html">Chi release notes</a>
      <ul class="sectlevel2">
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-6-0-2024-12-20">Version 6.0 (2024-12-20)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-5-0-2024-10-03">Version 5.0 (2024-10-03)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-4-0-2024-06-30">Version 4.0 (2024-06-30)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-3-0-2024-03-31">Version 3.0 (2024-03-31)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-2-0-2023-12-22">Version 2.0 (2023-12-22)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-1-0-2023-09-30">Version 1.0 (2023-09-30)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-0-10-2023-06-30">Version 0.10 (2023-06-30)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-0-9-2023-03-31">Version 0.9 (2023-03-31)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-0-8-2022-12-21">Version 0.8 (2022-12-21)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-0-7-2022-09-30">Version 0.7 (2022-09-30)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-0-6-2022-07-07">Version 0.6 (2022-07-07)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-0-5-2022-03-29">Version 0.5 (2022-03-29)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-0-4-2021-12-17">Version 0.4 (2021-12-17)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-0-3-2021-10-01">Version 0.3 (2021-10-01)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-0-2-2021-07-07">Version 0.2 (2021-07-07)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-0-1-2021-04-02">Version 0.1 (2021-04-02)</a></li>
      </ul></li>
     <li class="toc-item">
      <div class="toc-item-marker"></div><a href="../documentation-legal.html">Legal</a></li>
    </ul>
   </div>
  </div>
  <div id="content">
   <div id="breadcrumbs">
    <a class="breadcrumb" href="../documentation.html">Chi documentation</a> &gt; <a class="breadcrumb" href="index.html">Chi Tutorial</a> &gt; <span class="breadcrumb">Buffers</span>
   </div>
   <h2 id="buffers"><a class="anchor" href="#"></a>Buffers</h2>
   <div class="paragraph">
    <p>In the previous chapter, a production system was discussed that passes values from one process to the next using channels, in a synchronous manner. (Sender and receiver perform the communication at exactly the same moment in time, and the communication is instantaneous.) In many systems however, processes do not use synchronous communication, they use <em>asynchronous</em> communication instead. Values (products, packets, messages, simple tokens, and so on) are sent, temporarily stored in a buffer, and then received.</p>
   </div>
   <div class="paragraph">
    <p>In fact, the decoupling of sending and receiving is very important, it allows compensating temporarily differences between the number of items that are sent and received. (Under the assumption that the receiver is fast enough to keep up with the sender in general, otherwise the buffer will grow forever or overflow.)</p>
   </div>
   <div class="paragraph">
    <p>For example, consider the exchange of items from a producer process <code>P</code> to a consumer process <code>C</code> as shown in the following figure:</p>
   </div>
   <div id="tut-figure-pc2" class="imageblock">
    <div class="content">
     <img src="pictures/producer_consumer.png" alt="producer consumer">
    </div>
   </div>
   <div class="paragraph">
    <p>In the unbuffered situation, both processes communicate at the same time. This means that when one process is (temporarily) faster than the other, it has to wait for the other process before communication can take place. With a buffer in-between, the producer can give its item to the buffer, and continue with its work. Likewise, the consumer can pick up a new item from the buffer at any later time (if the buffer has items).</p>
   </div>
   <div class="paragraph">
    <p>In Chi, buffers are not modeled as channels, they are modeled as additional processes instead. The result is shown in the following figure:</p>
   </div>
   <div id="tut-figure-pbc" class="imageblock">
    <div class="content">
     <img src="pictures/buffered_producer_consumer.png" alt="buffered producer consumer">
    </div>
   </div>
   <div class="paragraph">
    <p>The producer sends its items synchronously (using channel <code>a</code>) to the buffer process. The buffer process keeps the item until it is needed. The consumer gets an item synchronously (using channel <code>b</code>) from the buffer when it needs a new item (and one is available).</p>
   </div>
   <div class="paragraph">
    <p>In manufacturing networks, buffers, in combination with servers, play a prominent role, for buffering items in the network. Various buffer types exist in these networks: buffers can have a finite or infinite capacity, they have a input/output discipline, for example a first-out queuing discipline or a priority-based discipline. Buffers can store different kinds of items, for example, product-items, information-items, or a combination of both. Buffers may also have sorting facilities, etc.</p>
   </div>
   <div class="paragraph">
    <p>In this chapter some buffer types are described, and with the presented concepts numerous types of buffer can be designed by the engineer. First a simple buffer process with one buffer position is presented, followed by more advanced buffer models. The producer and consumer processes are not discussed in this chapter.</p>
   </div>
   <div class="sect3">
    <h3 id="a-one-place-buffer"><a class="anchor" href="#a-one-place-buffer"></a>A one-place buffer</h3>
    <div class="paragraph">
     <p>A buffer usually has a receiving channel and a sending channel, for receiving and sending items. A buffer, buffer <code>B1</code>, is presented in the figure below:</p>
    </div>
    <div id="tut-figure-oneplacebuffer" class="imageblock">
     <div class="content">
      <img src="pictures/one_place_buffer.png" alt="one place buffer">
     </div>
    </div>
    <div class="paragraph">
     <p>The simplest buffer is a one-place buffer, for buffering precisely one item. A one-place buffer can be defined by:</p>
    </div>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-chi hljs" data-lang="chi">proc B1(chan? item a; chan! item b):
    item x;

    while true:
        a?x; b!x
    end
end</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>where <code>a</code> and <code>b</code> are the receiving and sending channels. Item <code>x</code> is buffered in the process. A buffer receives an item, stores the item, and sends the item to the next process, if the next process is willing to receive the item. The buffer is not willing to receive a second item, as long as the first item is still in the buffer.</p>
    </div>
    <div class="paragraph">
     <p>A two-place buffer can be created, by using the one-place buffer process twice. A two-place buffer is depicted below:</p>
    </div>
    <div id="tut-figure-twoplacebuffer" class="imageblock">
     <div class="content">
      <img src="pictures/two_place_buffer.png" alt="two place buffer">
     </div>
    </div>
    <div class="paragraph">
     <p>A two-place buffer is defined by:</p>
    </div>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-chi hljs" data-lang="chi">proc B2(chan? item a; chan! item b):
    chan item c;

    run B1(a, c), B1(c, b)
end</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>where two processes <code>B1</code> buffer maximal two items. If each process <code>B1</code> contains an item, a third item has to wait in front of process <code>B2</code>. This procedure can be extended to create even larger buffers. Another, more preferable manner however, is to describe a buffer in a single process by using a <em>select</em> statement and a list for storage of the items. Such a buffer is discussed in the next section.</p>
    </div>
   </div>
   <div class="sect3">
    <h3 id="a-single-process-buffer"><a class="anchor" href="#a-single-process-buffer"></a>A single process buffer</h3>
    <div class="paragraph">
     <p>An informal description of the process of a buffer, with an arbitrary number of stored items, is the following:</p>
    </div>
    <div class="olist arabic">
     <ol class="arabic">
      <li>
       <p>If the buffer has space for an item, <em>and</em> can receive an item from another process via channel <code>a</code>, the buffer process receives that item, and stores the item in the buffer.</p></li>
      <li>
       <p>If the buffer contains at least one item, <em>and</em> the buffer can send that item to another process via channel <code>b</code>, the buffer process sends that item, and removes that item from the buffer.</p></li>
      <li>
       <p>If the buffer can both send and receive a value, the buffer process selects one of the two possibilities (in a non-deterministic manner).</p></li>
      <li>
       <p>If the buffer cannot receive an item, and cannot send an item, the buffer process waits.</p></li>
     </ol>
    </div>
    <div class="paragraph">
     <p>Next to the sending and receiving of items (to and from the buffer process) is the question of how to order the stored items. A common form is the <em>first-in first-out</em> (fifo) queuing discipline. Items that enter the buffer first (first-in) also leave first (first-out), the order of items is preserved by the buffer process.</p>
    </div>
    <div class="paragraph">
     <p>In the model of the buffer, an (ordered) list of type <code>item</code> is used for storing the received items. New item <code>x</code> is added at the rear of list <code>xs</code> by the statement:</p>
    </div>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-chi hljs" data-lang="chi">xs = xs + [x]</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>The first item of the list is sent, and then deleted with:</p>
    </div>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-chi hljs" data-lang="chi">xs = xs[1:]</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>An alternative solution is to swap the function of the rear and the front, which can be useful some times.</p>
    </div>
    <div class="paragraph">
     <p>The statement to monitor several channels at the same time is the <code>select</code> statement. The syntax of the <code>select</code> statement, with two alternatives, is:</p>
    </div>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-chi hljs" data-lang="chi">select
    boolean_expression_1, communication statement_1:
        statement_list_1
alt
    boolean_expression_2, communication statement_2:
        statement_list_2
...
end</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>There has to be at least one alternative in a select statement. The statement waits, until for one of the alternatives the <code>boolean_expression</code> holds <em>and</em> communication using the <code>communication statement</code> is possible. (When there are several such alternatives, one of them is non-deterministically chosen.) For the selected alternative, the communication statement is executed, followed by the statements in the <code>statement_list</code> of the alternative.</p>
    </div>
    <div class="paragraph">
     <p>The above syntax is the most generic form, the <code>boolean_expression</code> may be omitted when it always holds, or the <code>communication statement</code> may be omitted when there is no need to communicate. The <code>,</code> also disappears then. (Omitting both the boolean expression and the communication statement is not allowed.) Similarly, when the <code>statement_list</code> is empty or just <code>pass</code>, it may be omitted (together with the <code>:</code> in front of it).</p>
    </div>
    <div class="paragraph">
     <p>The description (in words) of the core of the buffer, from the start of this section, is translated in code, by using a <code>select</code> statement:</p>
    </div>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-chi hljs" data-lang="chi">select
    size(xs) &lt; N, a?x:
        xs = xs + [x]
alt
    size(xs) &gt; 0, b!xs[0]:
        xs = xs[1:]
end</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>In the first alternative, it is stated that, if the buffer is not full, and the buffer can receive an item, an item is received, and that item is added to the rear of the list. In the second alternative, it is stated that, if the buffer contains at least one item, and the buffer can send an item, the first item in the list is sent, and the list is updated. Please keep in mind that both the condition must hold and the communication must be possible <em>at the same moment</em>.</p>
    </div>
    <div class="paragraph">
     <p>The complete description of the buffer is:</p>
    </div>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-chi hljs" data-lang="chi">proc B(chan? item a; chan! item b):
    list item xs; item x;

    while true:
        select
            size(xs) &lt; N, a?x:
                xs = xs + [x]
        alt
            size(xs) &gt; 0, b!xs[0]:
                xs = xs[1:]
        end
    end
end</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>Instead of boolean expression <code>size(xs) &gt; 0</code>, expression <code>not empty(xs)</code> can be used, where <code>empty</code> is a function yielding <code>true</code> if the list is empty, otherwise <code>false</code>. In case the capacity of the buffer is infinite, expression <code>size(xs) &lt; N</code> can be replaced by <code>true</code>, or even omitted (including the comma).</p>
    </div>
   </div>
   <div class="sect3">
    <h3 id="an-infinite-buffer"><a class="anchor" href="#an-infinite-buffer"></a>An infinite buffer</h3>
    <div class="paragraph">
     <p>A buffer with infinite capacity can be written as:</p>
    </div>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-chi hljs" data-lang="chi">proc B(chan? item a; chan! item b):
    list item xs; item x;

    while true:
        select
            a?x:
                xs = xs + [x]
        alt
            not empty(xs), b!xs[0]:
                xs = xs[1:]
        end
    end
end</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>A first-in first-out buffer is also called a <em>queue</em>, while a first-in last-out buffer (<em>lifo</em> buffer), is called a <em>stack</em>. A description of a lifo buffer is:</p>
    </div>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-chi hljs" data-lang="chi">proc B(chan? item a; chan! item b):
    list item xs; item x;

    while true:
        select
            a?x:
                xs = [x] + xs
        alt
            not empty(xs), b!xs[0]:
                xs = xs[1:]
        end
    end
end</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>The buffer puts the last received item at the head of the list, and gets the first item from the list. An alternative is to put the last item at the rear of the list, and to get the last item from the list.</p>
    </div>
   </div>
   <div class="sect3">
    <h3 id="a-token-buffer"><a class="anchor" href="#a-token-buffer"></a>A token buffer</h3>
    <div class="paragraph">
     <p>In the next example, signals are buffered instead of items. The buffer receives and sends 'empty' items or <em>tokens</em>. Counter variable <code>w</code> of type <code>int</code> denotes the difference between the number of tokens received and the number of tokens sent. If the buffer receives a token, counter <code>w</code> is incremented; if the buffer sends a token, counter <code>w</code> is decremented. If the number of tokens sent is less than the number of tokens received, there are tokens in the buffer, and <code>w &gt; 0</code>. A receiving channel variable <code>a</code> of type <code>void</code> is defined for receiving tokens. A sending channel variable <code>b</code> of type <code>void</code> is defined for sending tokens. The buffer becomes:</p>
    </div>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-chi hljs" data-lang="chi">proc B(chan? void a; chan! void b):
    int w;

    while true:
        select
            a?:
                w = w + 1
        alt
            w &gt; 0, b!:
                w = w - 1
        end
    end
end</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>Note that variables of type <code>void</code> do not exist. Type <code>void</code> only can be used in combination with channels.</p>
    </div>
   </div>
   <div class="sect3">
    <h3 id="a-priority-buffer"><a class="anchor" href="#a-priority-buffer"></a>A priority buffer</h3>
    <div class="paragraph">
     <p>A buffer for items with different priority is described in this section. An item has a high priority or a normal priority. Items with a high priority should leave the buffer first.</p>
    </div>
    <div class="paragraph">
     <p>An item is a tuple with a field <code>prio</code>, denoting the priority, <code>0</code> for high priority, and <code>1</code> for normal priority:</p>
    </div>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-chi hljs" data-lang="chi">type item = tuple(...; int prio);</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>For the storage of items, two lists are used: a list for high priority items and a list for normal priority items. The two lists are described by a list with size two:</p>
    </div>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-chi hljs" data-lang="chi">list(2) list item xs;</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>Variable <code>xs[0]</code> contains the high priority items, <code>xs[1]</code> the normal priority items. The first item in the high priority list is denoted by <code>xs[0][0]</code>, etc.</p>
    </div>
    <div class="paragraph">
     <p>In the model the received items are, on the basis of the value of the <code>prio</code>-field in the item, stored in one of the two lists: one list for 'high' items and one list for 'normal' items. The discipline of the buffer is that items with a high priority leave the buffer first. The model is:</p>
    </div>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-chi hljs" data-lang="chi">proc BPrio(chan? item a; chan! item b):
    list(2) list item xs; item x;

    while true:
        select
            a?x:
                xs[x.prio] = xs[x.prio] + [x]
        alt
            not empty(xs[0]), b!xs[0][0]:
                xs[0] = xs[0][1:]
        alt
            empty(xs[0]) and not empty(xs[1]), b!xs[1][0]:
                xs[1] = xs[1][1:]
        end
    end
end</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>The buffer has two lists <code>xs[0]</code> and <code>xs[1]</code>. Received items <code>x</code> are stored in <code>xs[x.prio]</code> by the statement <code>xs[x.prio] = xs[x.prio] + [x]</code>.</p>
    </div>
    <div class="paragraph">
     <p>If the list high priority items (<code>xs[0]</code>) is not empty, items with high priority are sent. The first element in list <code>xs[0]</code> is element <code>xs[0][0]</code>. If there are no high priority items (list <code>xs[0]</code> is empty), and there are normal priority items (list <code>xs[1]</code> is not empty), the first element of list <code>xs[1]</code>, element <code>xs[1][0]</code>, is sent.</p>
    </div>
    <div class="paragraph">
     <p>Note that the order of the alternatives in the select statement does not matter, every alternative is treated in the same way.</p>
    </div>
   </div>
   <div class="sect3">
    <h3 id="exercises"><a class="anchor" href="#exercises"></a>Exercises</h3>
    <div class="olist arabic">
     <ol class="arabic">
      <li>
       <p>To study product flow to and from a factory, a setup as shown in the figure below is created:</p>
       <div id="tut-figure-controlled-factory" class="imageblock">
        <div class="content">
         <img src="pictures/controlled_factory.png" alt="controlled factory">
        </div>
       </div>
       <div class="paragraph">
        <p><code>F</code> is the factory being studied, generator <code>G</code> sends products into the factory, and exit process <code>E</code> retrieves finished products. The factory is tightly controlled by controller <code>C</code> that sends a signal to <code>G</code> or <code>E</code> before a product may be moved. The model is as follows:</p>
       </div>
       <div class="listingblock">
        <div class="content">
         <pre class="highlightjs highlight"><code class="language-chi hljs" data-lang="chi">proc G(chan! int a; chan? void sg):
    for i in range(10):
        sg?;
        a!i;
    end
end

proc F(chan? int a; chan! int b):
    ...
end

proc E(chan? int a; chan? void se):
    int x;

    while true:
        se?;
        a?x;
        write("E received %d\n", x);
    end
end

proc C(chan! void sg, se; int low, high):
    int count;

    while true:
        while count &lt; high:
            sg!;
            count = count + 1;
        end
        while count &gt; low:
            se!;
            count = count - 1;
        end
    end
end

model M():
    chan void sg, se;
    chan int gf, fe;

    run C(sg, se, 0, 1),
        G(gf, sg), F(gf, fe), E(fe, se);
end</code></pre>
        </div>
       </div>
       <div class="paragraph">
        <p>The number of products inserted by the generator has been limited to allow for manual inspection of results.</p>
       </div>
       <div class="olist loweralpha">
        <ol class="loweralpha" type="a">
         <li>
          <p>As a model of the factory, use a FIFO buffer process. Run the simulation, and check whether all products are received by the exit process.</p></li>
         <li>
          <p>Change the control policy to <code>low = 1</code> and <code>high = 4</code>. Predict the outcome, and verify with simulation.</p></li>
         <li>
          <p>The employees of the factory propose to stack the products in the factory to reduce the amount of space needed for buffering. Replace the factory process with a LIFO buffer process, run the experiments again, first with <code>low = 0</code> and <code>high = 1</code> and then with <code>low = 1</code> and <code>high = 4</code>.</p></li>
         <li>
          <p>You will notice that some products stay in the factory forever. Why does that happen? How should the policy be changed to ensure all products eventually leave the factory?</p></li>
        </ol>
       </div></li>
     </ol>
    </div>
   </div>
  </div>
  <script src="../assets/highlight.min.js"></script>
  <script src="../assets/languages/asciidoc.min.js"></script>
  <script src="../assets/languages/bash.min.js"></script>
  <script src="../assets/languages/bnf.min.js"></script>
  <script src="../assets/languages/c.min.js"></script>
  <script src="../assets/languages/chi.min.js"></script>
  <script src="../assets/languages/cif.min.js"></script>
  <script src="../assets/languages/console.min.js"></script>
  <script src="../assets/languages/css.min.js"></script>
  <script src="../assets/languages/dsm.min.js"></script>
  <script src="../assets/languages/java.min.js"></script>
  <script src="../assets/languages/javascript.min.js"></script>
  <script src="../assets/languages/markdown.min.js"></script>
  <script src="../assets/languages/mcrl2.min.js"></script>
  <script src="../assets/languages/none.min.js"></script>
  <script src="../assets/languages/plcst.min.js"></script>
  <script src="../assets/languages/properties.min.js"></script>
  <script src="../assets/languages/raildiagram.min.js"></script>
  <script src="../assets/languages/setext.min.js"></script>
  <script src="../assets/languages/shell.min.js"></script>
  <script src="../assets/languages/tooldef.min.js"></script>
  <script src="../assets/languages/xml.min.js"></script>
  <script>
if (!hljs.initHighlighting.called) {
  hljs.initHighlighting.called = true
  ;[].slice.call(document.querySelectorAll('pre.highlight > code[data-lang]')).forEach(function (el) { hljs.highlightElement(el) })
}
</script>
  <script type="text/x-mathjax-config">
MathJax.Hub.Config({
  messageStyle: "none",
  tex2jax: {
    inlineMath: [["\\(", "\\)"]],
    displayMath: [["\\[", "\\]"]],
    ignoreClass: "nostem|nolatexmath"
  },
  asciimath2jax: {
    delimiters: [["\\$", "\\$"]],
    ignoreClass: "nostem|noasciimath"
  },
  TeX: { equationNumbers: { autoNumber: "none" } }
})
MathJax.Hub.Register.StartupHook("AsciiMath Jax Ready", function () {
  MathJax.InputJax.AsciiMath.postfilterHooks.Add(function (data, node) {
    if ((node = data.script.parentNode) && (node = node.parentNode) && node.classList.contains("stemblock")) {
      data.math.root.display = "block"
    }
    return data
  })
})
</script>
  <script src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.9/MathJax.js?config=TeX-MML-AM_HTMLorMML"></script><!--
  Copyright (c) 2010, 2024 Contributors to the Eclipse Foundation

  See the NOTICE file(s) distributed with this work for additional
  information regarding copyright ownership.

  This program and the accompanying materials are made available under the terms
  of the MIT License which is available at https://opensource.org/licenses/MIT

  SPDX-License-Identifier: MIT
-->
  <div id="footer">
   <div id="footer-text">
    <span>Chi documentation</span> | <span>Copyright (c) 2010, 2024 Contributors to the Eclipse Foundation</span> | <span>version v6.0</span>
    <br><a href="https://www.eclipse.org">Eclipse Home</a> | <a href="https://www.eclipse.org/legal/privacy.php">Privacy Policy</a> | <a href="https://www.eclipse.org/legal/termsofuse.php">Terms of Use</a> | <a href="https://www.eclipse.org/legal/copyright.php">Copyright Agent</a> | <a href="https://www.eclipse.org/legal">Eclipse Legal</a>
   </div>
  </div>
 </body>
</html>